/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

int dict_compare(const dict_t* s0, const dict_t* s1) {
    dnode_t *c0, *c1;
    size_t         i;
    int          cmp;

    if (s0 == s1)
        return 0;

    if (s0->size != s1->size)
        return s0->size < s1->size ? -1 : 1;

    i = s0->capacity;

    while (i--) {
        c0 = s0->nodes[i];

        while (!is_null(c0)) {

            c1  = s1->nodes[vnode_hash(&c0->key, c0->key_type) % s1->capacity];
            cmp = -1;

            while (!is_null(c1)) {
                if ((cmp = vnode_compare(&c0->key, c0->key_type, &c1->key, c1->key_type) == 0)) {

                    cmp = vnode_compare(&c0->value, c0->value_type, &c1->value, c1->value_type);
                    break;
                }

                c1 = c1->prev;
            }

            if (cmp) return cmp;

            c0 = c0->prev;
        }
    }

    return 0;
}
