/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../../include/dict.h"
#include "../__internal/assert.h"
#include "../__internal/rbtree.h"

#ifndef LIBCDSB_SRC_DICT_INCLUDE_H
#define LIBCDSB_SRC_DICT_INCLUDE_H

#ifndef DICT_CAPACITY_BLOCK
#define CAPACITY_BLOCK   100
#else
#define CAPACITY_BLOCK DICT_CAPACITY_BLOCK
#endif
#define REBUILD_POINT_MAX 0.65


typedef struct libcdsb_dict_node {
    struct libcdsb_dict_node* prev;

    vnode_t key;
    vnode_t value;

    u16_t key_type;
    u16_t value_type;
} dnode_t;


#endif /* LIBCDSB_SRC_DICT_INCLUDE_H */
