/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

void dict_free(dict_t* x) {
    if (is_null(x)) return;

    while (x->capacity--) {
        while (!is_null(x->nodes[x->capacity])) {
            vnode_free(&x->nodes[x->capacity]->key,   x->nodes[x->capacity]->key_type);
            vnode_free(&x->nodes[x->capacity]->value, x->nodes[x->capacity]->value_type);

            x->nodes[x->capacity] = x->nodes[x->capacity]->prev;
        }
    }

    free(x->nodes);
    memset(x, 0, sizeof(*x));
}
