/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

void list_free(list_t* x) {
    lnode_t* c;
    lnode_t* next;

    if (is_null(x)) return;

    c = x->first;

    while (!is_null(c)) {
        next = c->next;
        vnode_free(&c->node, c->type);
        free(c);
        c = next;
    }

    memset(x, 0, sizeof(*x));
}
