/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../../include/vtype.h"
#include "../../src/__internal/vnode.h"

#ifndef LIBCDSB_TESTS_RANDOM_H
#define LIBCDSB_TESTS_RANDOM_H

typedef struct {
    var_t value[1];
    vtype type;
} value_t;

extern int random_init(int argc, char** argv);

extern vtype_bool    random_boolean();
extern vtype_float   random_float();
extern vtype_double  random_double();
extern vtype_ldouble random_ldouble();

extern vtype_uint8  random_uint8();
extern vtype_uint16 random_uint16();
extern vtype_uint32 random_uint32();
extern vtype_uint64 random_uint64();

extern vtype_int8  random_int8();
extern vtype_int16 random_int16();
extern vtype_int32 random_int32();
extern vtype_int64 random_int64();

extern char random_ascii_char();
extern unsigned int random_unicode_symbol();

extern value_t random_value();

#endif /* LIBCDSB_TESTS_RANDOM_H */
