/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../plug.h"

static int node_print_callback(const void* k, vtype kt, void* v, vtype vt, void* _) {
    print_container_value(0, k, kt, 0, *(unsigned int*)_);
    return 0;
}

void dict_print(dict_t* x, const char* prefix, unsigned int hpos) {
    print_container_values_prefix("Dict", prefix, 0);
    dict_foreach(x, &hpos, node_print_callback);
    put_separator(0);
}

void dict_info(const dict_t* x, unsigned int hpos) {
    print_container_info("Dict", "nodes", 0, dict_size(x), -1, 0);
    put_separator(0);
}

void visual_push(dict_t* x, size_t n) {
    while (n--) {
        fputs("\e[s", stdout);

        dict_push_random(x, 0, 0);

        dict_info(x, 0);
        dict_print(x, 0, 0);

        psleep(100000);
        fputs("\e[u\e[J", stdout);
    }
}

void visual_remove(dict_t* x) {
    while (x->size) {
        fputs("\e[s", stdout);
        dict_remove_random(x, 0, 0);

        dict_info(x, 0);
        dict_print(x, 0, 0);

        psleep(100000);
        fputs("\e[u\e[J", stdout);
    }
}
