/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../plug.h"

void map_info(const map_t* x, unsigned int hpos) {
    print_container_info("Map", "nodes", &x->type, map_size(x), -1, 0);
    put_separator(0);
}

void array_info(arr_t* x, unsigned int hpos) {
    print_container_info("Array", "nodes", 0, array_size(x), -1, hpos);
}


void dict_info(const dict_t* x, unsigned int hpos) {
    print_container_info("Dict", "nodes", 0, dict_size(x), -1, 0);
    put_separator(0);
}

void list_info(list_t* x, unsigned int hpos) {
    print_container_info("List", "nodes", 0, list_size(x), -1, hpos);
}

void vset_info(const set_t* x, unsigned int hpos) {
    print_container_info("Set", "nodes", &x->type, vset_size(x), -1, 0);
    put_separator(0);
}

void string_info(str_t* x) {
    print_container_info("String", "utf8 chars", 0, string_size(x), string_nmemb(x), 0);
    put_separator(0);
}
