/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "plug.h"


int main(int argc, char** argv) {
    test_init(argc, argv);
    str_t x, y;
    int c = random_unicode_symbol();

    fputs("\e[s", stdout);
    x = string_random(30);
    string_print(&x, "(part 1)");

    string_concat(&x, '\n');
    string_concat_random(&x, 30);

    {
        char* repl = random_utf8_cstring(30);
        void* hack = at_string(&x, 31);
        string_print((void*)&hack, "(part 2)");
        string_print((void*)&repl, "(part 2 replaced)");
        string_replace(&x, hack, repl);
        free(repl);
    }

    string_info(&x);
    string_print(&x, "concatenated");

    do {
        string_replace_random(&x, 12);
    } while (string_size(&x) == string_nmemb(&x));

    y = string_copy(&x);

    string_to_lower(&x);
    string_to_upper(&y);

    visual_compare(&x, &y);
    visual_case_compare(&x, &y);

    string_reverse(&y);
    string_capitalize(&y);

    string_print(&y, "reversed & capitalized");

    string_free(&x);
    string_free(&y);

    psleep(900000);

    fputs("\e[u\e[J", stdout);

    x = string_random(12);

    string_align(&x, 30, 0);
    string_info(&x);
    string_print(&x, 0);

    string_trim(&x, 0);
    string_info(&x);
    string_print(&x, "trimmed");

    put_separator(0);
    string_align(&x, 30, c);
    string_info(&x);
    string_print(&x, 0);

    string_trim(&x, c);
    string_info(&x);
    string_print(&x, "trimmed");

    psleep(900000);

    string_free(&x);
}
