/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../plug.h"

void string_info(str_t* x) {
    print_container_info("String", "utf8 chars", 0, string_size(x), string_nmemb(x), 0);
    put_separator(0);
}

void string_print(const str_t* x, const char* prefix) {
    if (prefix) {
        printf("\e[36m%s %s content:\e[m\n", "String", prefix);
    } else printf("\e[36m%s content:\e[m\n", "String");

    printf("\e[33m\"%s\"\e[m\n", x->buffer);
    put_separator(0);
}

str_t string_random(unsigned int n) {
    str_t x;

    if (random_boolean()) {
        x.buffer = random_utf8_cstring(n);
    } else x.buffer = random_ascii_cstring(n);

    return x;
}

void visual_compare(const str_t* s0, const str_t* s1) {
    int c = string_compare(s0, s1);
    char* m;
    if (c == 0) m = "==";
    else m = (c < 0) ? "<" : ">";

    puts("\e[36mStrings comparsion:\e[m\n");
    printf("\e[33m\"%s\"\e[m \e[31m%s\e[m \e[33m\"%s\"\e[m\n", s0->buffer, m, s1->buffer);
}

void visual_case_compare(const str_t* s0, const str_t* s1) {
    int c = string_case_compare(s0, s1);
    char* m;
    if (c == 0) m = "==";
    else m = (c < 0) ? "<" : ">";

    puts("\e[36mStrings case insensitive comparsion:\e[m\n");
    printf("\e[33m\"%s\"\e[m \e[31m%s\e[m \e[33m\"%s\"\e[m\n", s0->buffer, m, s1->buffer);
}
