/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../plug.h"

char* random_ascii_cstring(size_t size) {
    char* v = malloc(size + 1);
    char* p = v;

    while (size--) {
        *(p++) = random_ascii_char();
    }
    *p = 0;

    return v;
}

char* random_utf8_cstring(size_t size) {
    char* v = malloc(size * 4 + 1);
    char* p = v;

    while (size--) {
        p = tochar_unicode(p, random_unicode_symbol());
    }

    *p = 0;
    return v;
}

void string_concat_random(str_t* x, unsigned int n) {
    char* v;

    if (random_boolean()) {
        v = random_utf8_cstring(n);
    } else v = random_ascii_cstring(n);

    string_concat(x, v);
    free(v);
}

void string_replace_random(str_t* x, unsigned int n) {
    char* v;

    if (random_boolean()) {
        v = random_utf8_cstring(n);
    } else v = random_ascii_cstring(n);

    string_replace(x, x, v);

    free(v);
}
